<?php if (!defined('PmWiki')) exit();
/**
  DDMU: Drag & Drop multiple asynchronous file uploader for PmWiki
  Written by (c) Petko Yotov 2011-2023 http://pmwiki.org/petko

  This text is written for PmWiki; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 3 of the License, or
  (at your option) any later version. See pmwiki.php for full details
  and lack of warranty.
*/
# Version date
$RecipeInfo['DragDropMultiUpload']['Version'] = '20231226';

$PostConfig['DDMU_js'] = 200;

if(@$_REQUEST['ddmu']) {
  $UploadRedirectFunction = 'DDMURedirect';
  $_POST['ddmu'] = 1;
  $EnableRedirect = 0;
  foreach(explode(' ', 'Header Footer Left Right Action Title') as $k) {
    SetTmplDisplay("Page{$k}Fmt",0);
  }
}
function DDMURedirect($pn, $url) {
  if(@$_POST['authpw']>'' || @$_GET['insattach']>'') # async login succeeded
    die(XL("Login successful, you can now upload."));
  die (FmtPageName($url, $pn));
}

function DDMU_js($pagename) {
  global $HTMLStylesFmt, $HTMLHeaderFmt, $UploadExtSize, $XL, $DDMUDirUrl,
    $DDMUHeaderFmt, $PageUrl, $DDMUEnableDropzone, $DDMUEnableQueue, $Author,
    $action, $EnableBrowseDDMU, $DDMUEnableAbsoluteAttachLinks, $FmtV, $VersionNum;
  $skip = 1;
  if ($action=='edit' || $action == 'upload') $skip = 0;
  if ($action == 'browse' && IsEnabled($EnableBrowseDDMU, 0) ) $skip = 0;
  if ($skip) return;

  XLSDV('en', array(
    'ULuploading'=>"uploading...",
    'ULunknown_error'=>"unknown error",
    'ULlogin'=>XL("Password required"),
    'ULdd_pagename'=>$pagename,
    'ULdd_pageurl'=>PageVar($pagename, '$PageUrl'),
    'ULdropzone_innerHTML'=>"Drop files to upload: ",
    'ULdd_enable_dropzone'=>IsEnabled($DDMUEnableDropzone, 0),
    'ULdd_enable_queue'=>IsEnabled($DDMUEnableQueue, 0),
    'ULdirurl'=>FmtPageName($DDMUDirUrl, $pagename),
    'ULdd_absattachlinks'=>IsEnabled($DDMUEnableAbsoluteAttachLinks, 0),
  ));

  $json = array();
  $json['codes'] = array();
  $json['sizes'] = $UploadExtSize;
  if(isset($json['sizes'][''])) $json['sizes']['/'] = $json['sizes'][''];

  $codes = array();
  $ULkeys = preg_grep('/^UL/', array_keys($XL['en']));
  
  
  foreach($ULkeys as $k) {
    $codes[] = "'".substr($k, 2)."': \"".str_replace(array('"', "\n", '$'), array("&quot;", " ", "\\x24"), XL($k))."\"";
    $json['codes'][substr($k, 2)] = XL($k);
  }
  
  if($VersionNum>=2003023) {
    $json['codes']['tokenname'] = $FmtV['$TokenName'];
    $json['codes']['tokenvalue'] = pmtoken();
  }
  
  if(@$Author) {
    $json['codes']['author'] = $Author;
  }
  
  $dataconf = pm_json_encode($json, true);
  $dataconf = str_replace('$', '&#36;', $dataconf);

  SDV($DDMUDirUrl, '$FarmPubDirUrl/ddmu');
  SDVA($DDMUHeaderFmt, array(
    'unverse.js' => "<script type='text/javascript' src='$DDMUDirUrl/unverse.js'></script>\n",
    'ddmu.js'    => "<script type='text/javascript' src='$DDMUDirUrl/ddmu.js' 
      data-conf=\"$dataconf\"></script>\n",
    'ddmu.css'   => "<link rel='stylesheet' href='$DDMUDirUrl/ddmu.css' type='text/css' media='screen'/>\n",
  ));
  SDVA($HTMLHeaderFmt, $DDMUHeaderFmt);
}
